Index: gnu/usr.bin/perl/pod/perlhist.pod
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/pod/perlhist.pod,v
diff -u -p -a -u -p -r1.29 perlhist.pod
--- gnu/usr.bin/perl/pod/perlhist.pod	8 Jul 2023 14:18:36 -0000	1.29
+++ gnu/usr.bin/perl/pod/perlhist.pod	20 Dec 2023 03:20:10 -0000
@@ -35,7 +35,7 @@ Little, Dave Rolsky, Max Maischein, Abig
 Dominic Hargreaves, Aaron Crane, Aristotle Pagaltzis, Matthew Horsfall,
 Peter Martini, Sawyer X, Chad 'Exodist' Granum, Renee Bäcker, Eric Herman,
 John SJ Anderson, Karen Etheridge, Zak B. Elep, Tom Hukins, Richard Leach,
-Neil Bowers and Yves Orton.
+Neil Bowers, Yves Orton, Paul Evans, and Graham Knop.
 
 =head2 PUMPKIN?
 
@@ -716,6 +716,8 @@ the strings?).
  Steve     5.34.1-RC1   2022-Feb-27
  Steve     5.34.1-RC2   2022-Mar-06
  Steve     5.34.1       2022-Mar-13
+ Paul E    5.34.2       2023-Nov-25
+ Paul E    5.34.3       2023-Nov-29
 
  Ricardo   5.35.0       2021-May-20     The 5.35 development track
  Max       5.35.1       2021-Jun-20
@@ -738,6 +740,8 @@ the strings?).
  Steve     5.36.1-RC2   2023-Apr-11
  Steve     5.36.1-RC3   2023-Apr-16
  Steve     5.36.1       2023-Apr-23
+ Paul E    5.36.2       2023-Nov-25
+ Paul E    5.36.3       2023-Nov-29
 
  Ricardo   5.37.0       2022-May-27     The 5.37 development track
  Matthew H 5.37.1       2022-Jun-20
@@ -752,6 +756,19 @@ the strings?).
  Yves      5.37.10      2023-Mar-20
  Steve     5.37.11      2023-Apr-20
 
+ Ricardo   5.38.0-RC1   2023-Jun-15     The 5.38 maintenance track
+ Ricardo   5.38.0-RC2   2023-Jun-23
+ Ricardo   5.38.0       2023-Jul-02
+ Paul E    5.38.1       2023-Nov-25
+ Paul E    5.38.2       2023-Nov-29
+
+ Ricardo   5.39.0       2023-Jun-30     The 5.39 development track
+ Steve     5.39.1       2023-Jul-20
+ Paul E    5.39.2       2023-Aug-20
+ Matthew H 5.39.3       2023-Sep-20
+ Graham K  5.39.4       2023-Oct-25
+ Ether     5.39.5       2023-Nov-20
+
 =head2 SELECTED RELEASE SIZES
 
 For example the notation "core: 212  29" in the release 1.000 means that
@@ -840,6 +857,7 @@ explained below.
  5.32.0        14147 127  25562 1255 40869 3098  11334 2734   8407 225
  5.34.0        14620 126  28150 1262 42711 3138  11535 2774   8791 228
  5.36.0        15300 129  27899 1270 48275 3236  11899 2863   8858 224
+ 5.38.0        15793 139  29070 1270 48250 3219  11950 2863   9129 239
 
 The "core"..."doc" mean the following files from the Perl source code
 distribution.  The glob notation ** means recursively, (.) means
@@ -1204,18 +1222,20 @@ the Perl source distribution for somewha
  vos           12      7        12      7         8      7
  win32       1011     47      1001     46       966     45
 
+                  5.38.0
 
-
-
-
-
-
-
-
-
-
-
-
+ Configure    604      1
+ Cross        122     15
+ h2pl          13     15
+ hints        358     83
+ os2          538     70
+ plan9        322     20
+ Porting     1640     80
+ qnx            1      4
+ utils        606     52
+ vms          544     12
+ vos            8      7
+ win32        982     45
 
 =head2 SELECTED PATCH SIZES
 
Index: gnu/usr.bin/perl/t/win32/system.t
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/t/win32/system.t,v
diff -u -p -a -u -p -r1.2 system.t
--- gnu/usr.bin/perl/t/win32/system.t	5 Feb 2017 00:32:21 -0000	1.2
+++ gnu/usr.bin/perl/t/win32/system.t	20 Dec 2023 03:20:10 -0000
@@ -82,6 +82,7 @@ close $F;
 chdir($testdir);
 END {
     chdir($cwd) && rmtree("$cwd/$testdir") if -d "$cwd/$testdir";
+    unlink "cmd.exe";
 }
 if (open(my $EIN, "$cwd/win32/${exename}_exe.uu")) {
     note "Unpacking $exename.exe";
@@ -104,21 +105,20 @@ else {
      }
     note "Compiling $exename.c";
     note "$Config{cc} $Config{ccflags} $exename.c";
-    if (system("$Config{cc} $Config{ccflags} $minus_o $exename.c >log 2>&1") != 0) {
+    if (system("$Config{cc} $Config{ccflags} $minus_o $exename.c >log 2>&1") != 0 ||
+        !-f "$exename.exe") {
 	note "Could not compile $exename.c, status $?";
-    note "Where is your C compiler?";
-    skip_all "can't build test executable";
-    }
-    unless (-f "$exename.exe") {
-	if (open(LOG,'<log'))
-         {
-          while(<LOG>) {
-              note $_;
-          } 
-         }
+        note "Where is your C compiler?";
+        if (open(LOG,'<log'))
+        {
+            while(<LOG>) {
+                note $_;
+            }
+        }
         else {
-	  warn "Cannot open log (in $testdir):$!";
+            warn "Cannot open log (in $testdir):$!";
         }
+        skip_all "can't build test executable";
     }
 }
 copy("$plxname.bat","$plxname.cmd");
@@ -127,6 +127,12 @@ unless (-x "$testdir/$exename.exe") {
     note "Could not build $exename.exe";
     skip_all "can't build test executable";
 }
+
+# test we only look for cmd.exe in the standard place
+delete $ENV{PERLSHELL};
+copy("$testdir/$exename.exe", "$testdir/cmd.exe") or die $!;
+copy("$testdir/$exename.exe", "cmd.exe") or die $!;
+$ENV{PATH} = qq("$testdir";$ENV{PATH});
 
 open my $T, "$^X -I../lib -w win32/system_tests |"
     or die "Can't spawn win32/system_tests: $!";
Index: gnu/usr.bin/perl/vms/descrip_mms.template
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/vms/descrip_mms.template,v
diff -u -p -a -u -p -r1.13 descrip_mms.template
--- gnu/usr.bin/perl/vms/descrip_mms.template	8 Jul 2023 14:18:37 -0000	1.13
+++ gnu/usr.bin/perl/vms/descrip_mms.template	20 Dec 2023 03:20:10 -0000
@@ -313,7 +313,7 @@ utils : $(utils1) $(utils2) $(utils3) $(
 extra.pods : miniperl
 	@ @extra_pods.com
 
-PERLDELTA_CURRENT = [.pod]perl5361delta.pod
+PERLDELTA_CURRENT = [.pod]perl5363delta.pod
 
 $(PERLDELTA_CURRENT) : [.pod]perldelta.pod
 	Copy/NoConfirm/Log $(MMS$SOURCE) $(PERLDELTA_CURRENT)
Index: gnu/usr.bin/perl/win32/GNUmakefile
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/win32/GNUmakefile,v
diff -u -p -a -u -p -r1.22 GNUmakefile
--- gnu/usr.bin/perl/win32/GNUmakefile	8 Jul 2023 14:18:37 -0000	1.22
+++ gnu/usr.bin/perl/win32/GNUmakefile	20 Dec 2023 03:20:10 -0000
@@ -63,7 +63,7 @@ INST_TOP := $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	:= \5.36.1
+#INST_VER	:= \5.36.3
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -1624,7 +1624,7 @@ utils: $(HAVEMINIPERL) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5361delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5363delta.pod
 	$(MINIPERL) -I..\lib $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl ..
 	$(MINIPERL) -I..\lib ..\pod\perlmodlib.PL -q ..
@@ -1724,7 +1724,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5361delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5363delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlcn.pod perlcygwin.pod \
 	    perlfreebsd.pod perlhaiku.pod perlhpux.pod perlhurd.pod \
 	    perlintern.pod perlirix.pod perljp.pod perlko.pod perllinux.pod \
Index: gnu/usr.bin/perl/win32/Makefile
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/win32/Makefile,v
diff -u -p -a -u -p -r1.47 Makefile
--- gnu/usr.bin/perl/win32/Makefile	8 Jul 2023 14:18:37 -0000	1.47
+++ gnu/usr.bin/perl/win32/Makefile	20 Dec 2023 03:20:10 -0000
@@ -37,7 +37,7 @@ INST_TOP	= $(INST_DRV)\perl
 # versioned installation can be obtained by setting INST_TOP above to a
 # path that includes an arbitrary version string.
 #
-#INST_VER	= \5.36.1
+#INST_VER	= \5.36.3
 
 #
 # Comment this out if you DON'T want your perl installation to have
@@ -1156,7 +1156,7 @@ utils: $(PERLEXE) ..\utils\Makefile
 	copy ..\README.tw       ..\pod\perltw.pod
 	copy ..\README.vos      ..\pod\perlvos.pod
 	copy ..\README.win32    ..\pod\perlwin32.pod
-	copy ..\pod\perldelta.pod ..\pod\perl5361delta.pod
+	copy ..\pod\perldelta.pod ..\pod\perl5363delta.pod
 	cd ..\win32
 	$(PERLEXE) $(PL2BAT) $(UTILS)
 	$(MINIPERL) -I..\lib ..\autodoc.pl ..
@@ -1257,7 +1257,7 @@ distclean: realclean
 	-if exist $(LIBDIR)\Win32API rmdir /s /q $(LIBDIR)\Win32API
 	-if exist $(LIBDIR)\XS rmdir /s /q $(LIBDIR)\XS
 	-cd $(PODDIR) && del /f *.html *.bat roffitall \
-	    perl5361delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
+	    perl5363delta.pod perlaix.pod perlamiga.pod perlandroid.pod \
 	    perlapi.pod perlbs2000.pod perlcn.pod perlcygwin.pod \
 	    perlfreebsd.pod perlhaiku.pod perlhpux.pod perlhurd.pod \
 	    perlintern.pod perlirix.pod perljp.pod perlko.pod perllinux.pod \
Index: gnu/usr.bin/perl/win32/pod.mak
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/win32/pod.mak,v
diff -u -p -a -u -p -r1.28 pod.mak
--- gnu/usr.bin/perl/win32/pod.mak	8 Jul 2023 14:18:37 -0000	1.28
+++ gnu/usr.bin/perl/win32/pod.mak	20 Dec 2023 03:20:10 -0000
@@ -66,8 +66,12 @@ POD = perl.pod	\
 	perl5321delta.pod	\
 	perl5340delta.pod	\
 	perl5341delta.pod	\
+	perl5342delta.pod	\
+	perl5343delta.pod	\
 	perl5360delta.pod	\
 	perl5361delta.pod	\
+	perl5362delta.pod	\
+	perl5363delta.pod	\
 	perl561delta.pod	\
 	perl56delta.pod	\
 	perl581delta.pod	\
@@ -232,8 +236,12 @@ MAN = perl.man	\
 	perl5321delta.man	\
 	perl5340delta.man	\
 	perl5341delta.man	\
+	perl5342delta.man	\
+	perl5343delta.man	\
 	perl5360delta.man	\
 	perl5361delta.man	\
+	perl5362delta.man	\
+	perl5363delta.man	\
 	perl561delta.man	\
 	perl56delta.man	\
 	perl581delta.man	\
@@ -398,8 +406,12 @@ HTML = perl.html	\
 	perl5321delta.html	\
 	perl5340delta.html	\
 	perl5341delta.html	\
+	perl5342delta.html	\
+	perl5343delta.html	\
 	perl5360delta.html	\
 	perl5361delta.html	\
+	perl5362delta.html	\
+	perl5363delta.html	\
 	perl561delta.html	\
 	perl56delta.html	\
 	perl581delta.html	\
@@ -564,8 +576,12 @@ TEX = perl.tex	\
 	perl5321delta.tex	\
 	perl5340delta.tex	\
 	perl5341delta.tex	\
+	perl5342delta.tex	\
+	perl5343delta.tex	\
 	perl5360delta.tex	\
 	perl5361delta.tex	\
+	perl5362delta.tex	\
+	perl5363delta.tex	\
 	perl561delta.tex	\
 	perl56delta.tex	\
 	perl581delta.tex	\
Index: gnu/usr.bin/perl/win32/win32.c
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/win32/win32.c,v
diff -u -p -a -u -p -r1.23 win32.c
--- gnu/usr.bin/perl/win32/win32.c	15 Feb 2023 01:36:37 -0000	1.23
+++ gnu/usr.bin/perl/win32/win32.c	20 Dec 2023 03:20:10 -0000
@@ -72,7 +72,7 @@
 int _CRT_glob = 0;
 #endif
 
-#if defined(__MINGW32__) && (__MINGW32_MAJOR_VERSION==1)	
+#if defined(__MINGW32__) && (__MINGW32_MAJOR_VERSION==1)
 /* Mingw32-1.1 is missing some prototypes */
 START_EXTERN_C
 FILE * _wfopen(LPCWSTR wszFileName, LPCWSTR wszMode);
@@ -116,7 +116,7 @@ static char*	win32_get_xlib(const char *
 
 static BOOL	has_shell_metachars(const char *ptr);
 static long	tokenize(const char *str, char **dest, char ***destv);
-static void	get_shell(void);
+static int	get_shell(void);
 static char*	find_next_space(const char *s);
 static int	do_spawn2(pTHX_ const char *cmd, int exectype);
 static int	do_spawn2_handles(pTHX_ const char *cmd, int exectype,
@@ -204,9 +204,9 @@ set_silent_invalid_parameter_handler(BOO
 
 static void
 my_invalid_parameter_handler(const wchar_t* expression,
-    const wchar_t* function, 
-    const wchar_t* file, 
-    unsigned int line, 
+    const wchar_t* function,
+    const wchar_t* file,
+    unsigned int line,
     uintptr_t pReserved)
 {
 #  ifdef _DEBUG
@@ -602,7 +602,13 @@ tokenize(const char *str, char **dest, c
     return items;
 }
 
-static void
+static const char
+cmd_opts[] = "/x/d/c";
+
+static const char
+shell_cmd[] = "cmd.exe";
+
+static int
 get_shell(void)
 {
     dTHX;
@@ -614,12 +620,53 @@ get_shell(void)
          *     interactive use (which is what most programs look in COMSPEC
          *     for).
          */
-        const char* defaultshell = "cmd.exe /x/d/c";
-        const char *usershell = PerlEnv_getenv("PERL5SHELL");
-        w32_perlshell_items = tokenize(usershell ? usershell : defaultshell,
-                                       &w32_perlshell_tokens,
-                                       &w32_perlshell_vec);
+        const char *shell = PerlEnv_getenv("PERL5SHELL");
+        if (shell) {
+            w32_perlshell_items = tokenize(shell,
+                                           &w32_perlshell_tokens,
+                                           &w32_perlshell_vec);
+        }
+        else {
+            /* tokenize does some Unix-ish like things like
+               \\ escaping that don't work well here
+            */
+            char shellbuf[MAX_PATH];
+            UINT len = GetSystemDirectoryA(shellbuf, sizeof(shellbuf));
+            if (len == 0) {
+                translate_to_errno();
+                return -1;
+            }
+            else if (len >= MAX_PATH) {
+                /* buffer too small */
+                errno = E2BIG;
+                return -1;
+            }
+            if (shellbuf[len-1] != '\\') {
+                my_strlcat(shellbuf, "\\", sizeof(shellbuf));
+                ++len;
+            }
+            if (len + sizeof(shell_cmd) > sizeof(shellbuf)) {
+                errno = E2BIG;
+                return -1;
+            }
+            my_strlcat(shellbuf, shell_cmd, sizeof(shellbuf));
+            len += sizeof(shell_cmd)-1;
+
+            Newx(w32_perlshell_vec, 3, char *);
+            Newx(w32_perlshell_tokens, len + 1 + sizeof(cmd_opts), char);
+
+            my_strlcpy(w32_perlshell_tokens, shellbuf, len+1);
+            my_strlcpy(w32_perlshell_tokens + len +1, cmd_opts,
+                       sizeof(cmd_opts));
+
+            w32_perlshell_vec[0] = w32_perlshell_tokens;
+            w32_perlshell_vec[1] = w32_perlshell_tokens + len + 1;
+            w32_perlshell_vec[2] = NULL;
+
+            w32_perlshell_items = 2;
+        }
     }
+    return 0;
 }
 
 int
@@ -637,7 +684,9 @@ Perl_do_aspawn(pTHX_ SV *really, SV **ma
     if (sp <= mark)
         return -1;
 
-    get_shell();
+    if (get_shell() < 0)
+        return -1;
+
     Newx(argv, (sp - mark) + w32_perlshell_items + 2, char*);
 
     if (SvNIOKp(*(mark+1)) && !SvPOKp(*(mark+1))) {
@@ -767,7 +816,8 @@ do_spawn2_handles(pTHX_ const char *cmd,
     if (needToTry) {
         char **argv;
         int i = -1;
-        get_shell();
+        if (get_shell() < 0)
+            return -1;
         Newx(argv, w32_perlshell_items + 2, char*);
         while (++i < w32_perlshell_items)
             argv[i] = w32_perlshell_vec[i];
@@ -2069,14 +2119,14 @@ win32_getenvironmentstrings(void)
     }
 
     /* Get the number of bytes required to store the ACP encoded string */
-    aenvstrings_len = WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS, 
+    aenvstrings_len = WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS,
                                           lpWStr, wenvstrings_len, NULL, 0, NULL, NULL);
     lpTmp = lpStr = (char *)win32_calloc(aenvstrings_len, sizeof(char));
     if(!lpTmp)
         out_of_memory();
 
     /* Convert the string from UTF-16 encoding to ACP encoding */
-    WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS, lpWStr, wenvstrings_len, lpStr, 
+    WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS, lpWStr, wenvstrings_len, lpStr,
                         aenvstrings_len, NULL, NULL);
 
     FreeEnvironmentStringsW(lpWStr);
@@ -2437,7 +2487,7 @@ win32_uname(struct utsname *name)
 /* Timing related stuff */
 
 int
-do_raise(pTHX_ int sig) 
+do_raise(pTHX_ int sig)
 {
     if (sig < SIG_SIZE) {
         Sighandler_t handler = w32_sighandler[sig];
@@ -2473,8 +2523,8 @@ void
 sig_terminate(pTHX_ int sig)
 {
     Perl_warn(aTHX_ "Terminating on signal SIG%s(%d)\n",PL_sig_name[sig], sig);
-    /* exit() seems to be safe, my_exit() or die() is a problem in ^C 
-       thread 
+    /* exit() seems to be safe, my_exit() or die() is a problem in ^C
+       thread
      */
     exit(sig);
 }
@@ -2525,7 +2575,7 @@ win32_async_check(pTHX)
     /* Above or other stuff may have set a signal flag */
     if (PL_sig_pending)
         despatch_signals();
-    
+
     return 1;
 }
 
@@ -3268,7 +3318,8 @@ win32_pipe(int *pfd, unsigned int size, 
 DllExport PerlIO*
 win32_popenlist(const char *mode, IV narg, SV **args)
 {
-    get_shell();
+    if (get_shell() < 0)
+        return NULL;
 
     return do_popen(mode, NULL, narg, args);
 }
